<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "cardinfo_t".
 *
 * @property integer $id
 * @property integer $order_id
 * @property string $cardnumber
 * @property string $address
 * @property string $name
 * @property string $nation
 * @property string $issuingauthority
 * @property string $validstartdate
 * @property string $validenddate
 * @property string $phone
 * @property string $samcode
 * @property integer $pingtai
 * @property integer $channels
 * @property string $user
 * @property string $password
 * @property string $created_at
 * @property string $updated_at
 */
class CardinfoT extends \common\models\Base
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'cardinfo_t';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['order_id'], 'required'],
            [['order_id', 'pingtai', 'channels'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['cardnumber', 'address', 'name', 'issuingauthority', 'samcode'], 'string', 'max' => 100],
            [['nation', 'validstartdate', 'validenddate', 'phone', 'user', 'password'], 'string', 'max' => 50],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'order_id' => 'Order ID',
            'cardnumber' => 'Cardnumber',
            'address' => 'Address',
            'name' => 'Name',
            'nation' => 'Nation',
            'issuingauthority' => 'Issuingauthority',
            'validstartdate' => 'Validstartdate',
            'validenddate' => 'Validenddate',
            'phone' => 'Phone',
            'samcode' => 'Samcode',
            'pingtai' => 'Pingtai',
            'channels' => 'Channels',
            'user' => 'User',
            'password' => 'Password',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
