<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "config_t".
 *
 * @property integer $id
 * @property string $name
 * @property string $super_password
 * @property string $super_salt
 * @property string $max_other_money
 * @property string $max_other_area_rate
 * @property string $max_dis_money
 * @property string $max_out_rate
 * @property string $created_at
 * @property string $updated_at
 */
class ConfigT extends \common\models\Base
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'config_t';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['created_at', 'updated_at'], 'safe'],
            [['name', 'super_password'], 'string', 'max' => 100],
            [['max_other_money', 'max_other_area_rate', 'max_dis_money', 'max_out_rate'], 'number'],
            [['super_salt'], 'string', 'max' => 10],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'super_password' => 'Super Password',
            'super_salt' => 'Super Salt',
            'max_other_money' => 'Max Other Money',
            'max_other_area_rate' => 'Max Other Area Rate',
            'max_dis_money' => 'Max Dis Money',
            'max_out_rate' => 'Max Out Rate',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
