<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "fix_car_report".
 *
 * @property integer $id
 * @property integer $fix_id
 * @property string $report_no
 * @property string $baoan_man
 * @property string $baoan_time
 * @property string $chuxian_time
 * @property string $baoan_address
 * @property string $shigu_info
 * @property string $lipei_company
 * @property string $zhuche_money
 * @property string $sanzhe_money
 * @property string $wusun_money
 * @property string $tuoche
 * @property string $tuoche_money
 * @property string $dingsun_hour_money
 * @property string $dingsun_huanjian_money
 * @property string $peifu_bili
 * @property string $peifu_money
 * @property string $kehu_money
 * @property string $created_at
 * @property string $updated_at
 */
class FixCarReport extends \common\models\Base
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'fix_car_report';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['fix_id'], 'integer'],
            [['baoan_time', 'chuxian_time', 'created_at', 'updated_at'], 'safe'],
            [['zhuche_money', 'sanzhe_money', 'wusun_money', 'tuoche_money', 'dingsun_hour_money', 'dingsun_huanjian_money', 'peifu_money', 'kehu_money'], 'number'],
            [['report_no', 'baoan_man', 'tuoche', 'peifu_bili'], 'string', 'max' => 50],
            [['baoan_address', 'shigu_info', 'lipei_company'], 'string', 'max' => 100],
            [['report_no'], 'unique'],
            [['report_no', 'baoan_man', 'baoan_time', 'chuxian_time', 'baoan_address', 'shigu_info', 'lipei_company', 'zhuche_money', 'sanzhe_money', 'wusun_money', 'tuoche', 'tuoche_money', 'dingsun_hour_money', 'dingsun_huanjian_money', 'peifu_bili', 'peifu_money', 'kehu_money'],'required']
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'fix_id' => 'Fix ID',
            'report_no' => '报案号',
            'baoan_man' => '报案人',
            'baoan_time' => '报案时间',
            'chuxian_time' => '出险时间',
            'baoan_address' => '出险地点',
            'shigu_info' => '事故描述',
            'lipei_company' => '理赔公司',
            'zhuche_money' => '车主定损金额',
            'sanzhe_money' => '三者外修',
            'wusun_money' => '物损',
            'tuoche' => '拖车',
            'tuoche_money' => '拖车费用',
            'dingsun_hour_money' => '定损工时费',
            'dingsun_huanjian_money' => '定损换件费',
            'peifu_bili' => '赔付比例',
            'peifu_money' => '赔付金额',
            'kehu_money' => '客户自付',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
