<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "fix_item_t".
 *
 * @property integer $id
 * @property integer $fix_id
 * @property string $name
 * @property string $price
 * @property integer $count
 * @property string $total
 * @property string $pay_type
 * @property string $pay_real
 * @property string $type
 * @property string $fix_user
 * @property string $fix_remark
 * @property integer $status
 * @property string $repair_remark
 * @property integer $big_type_id
 * @property integer $small_type_id
 * @property string $created_at
 * @property string $updated_at
 */
class FixItemT extends \common\models\Base
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'fix_item_t';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['fix_id', 'count', 'status', 'big_type_id', 'small_type_id'], 'integer'],
            [['price', 'total', 'pay_real'], 'number'],
            [['created_at', 'updated_at'], 'safe'],
            [['name', 'pay_type', 'fix_remark', 'repair_remark'], 'string', 'max' => 100],
            [['type', 'fix_user'], 'string', 'max' => 50],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'fix_id' => 'Fix ID',
            'name' => 'Name',
            'price' => 'Price',
            'count' => 'Count',
            'total' => 'Total',
            'pay_type' => 'Pay Type',
            'pay_real' => 'Pay Real',
            'type' => 'Type',
            'fix_user' => 'Fix User',
            'fix_remark' => 'Fix Remark',
            'status' => 'Status',
            'repair_remark' => 'Repair Remark',
            'big_type_id' => 'Big Type ID',
            'small_type_id' => 'Small Type ID',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
