<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "gz_t".
 *
 * @property integer $id
 * @property integer $sale_id
 * @property integer $year
 * @property integer $month
 * @property string $ycq
 * @property string $scq
 * @property string $yts
 * @property string $sts
 * @property string $hb
 * @property string $other
 * @property string $tx
 * @property string $cd
 * @property string $tb
 * @property string $sb
 * @property string $bd
 * @property integer $order_count
 * @property string $total1_clear
 * @property string $total1_rate
 * @property string $total1_dis
 * @property integer $gift1_count
 * @property string $gift1_total
 * @property integer $gift2_count
 * @property string $gift2_total
 * @property string $tj
 * @property string $tc
 * @property string $yf
 * @property string $lp
 * @property string $created_at
 * @property string $updated_at
 */
class GzT extends \common\models\Base
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'gz_t';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['sale_id', 'year', 'month'], 'required'],
            [['sale_id', 'year', 'month', 'order_count', 'gift1_count', 'gift2_count'], 'integer'],
            [['hb', 'other', 'tx', 'cd', 'tb', 'sb', 'bd', 'total1_clear', 'total1_rate', 'total1_dis', 'gift1_total', 'gift2_total', 'tj', 'tc', 'yf'], 'number'],
            [['created_at', 'updated_at'], 'safe'],
            [['ycq', 'scq', 'yts', 'sts', 'lp'], 'string', 'max' => 50],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'sale_id' => 'Sale ID',
            'year' => 'Year',
            'month' => 'Month',
            'ycq' => 'Ycq',
            'scq' => 'Scq',
            'yts' => 'Yts',
            'sts' => 'Sts',
            'hb' => 'Hb',
            'other' => 'Other',
            'tx' => 'Tx',
            'cd' => 'Cd',
            'tb' => 'Tb',
            'sb' => 'Sb',
            'bd' => 'Bd',
            'order_count' => 'Order Count',
            'total1_clear' => 'Total 1 Clear',
            'total1_rate' => 'Total 1 Rate',
            'total1_dis' => 'Total 1 Dis',
            'gift1_count' => 'Gift1 Count',
            'gift1_total' => 'Gift1 Total',
            'gift2_count' => 'Gift2 Count',
            'gift2_total' => 'Gift2 Total',
            'tj' => 'Tj',
            'tc' => 'Tc',
            'yf' => 'Yf',
            'lp' => 'Li Ping',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
