<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "phone_time_t".
 *
 * @property integer $id
 * @property integer $user_id
 * @property string $caller
 * @property integer $begin_time
 * @property integer $end_time
 * @property integer $call_time
 * @property string $created_at
 * @property string $updated_at
 */
class PhoneTimeT extends \common\models\Base
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'phone_time_t';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['user_id', 'caller'], 'required'],
            [['user_id', 'begin_time', 'end_time', 'call_time'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['caller'], 'string', 'max' => 100],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'user_id' => 'User ID',
            'caller' => 'Caller',
            'begin_time' => 'Begin Time',
            'end_time' => 'End Time',
            'call_time' => 'Call Time',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
