<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "wages_t".
 *
 * @property integer $id
 * @property integer $user_id
 * @property integer $year
 * @property integer $month
 * @property string $basic_wages
 * @property string $duties_wages
 * @property string $post_wages
 * @property string $check_work
 * @property integer $call_long
 * @property string $commission
 * @property string $encourage
 * @property string $reward
 * @property integer $overtime
 * @property string $traffic
 * @property string $bill
 * @property string $leader
 * @property string $subsidy
 * @property string $late
 * @property string $subsidy_ded
 * @property string $punish
 * @property string $electricity_fees
 * @property string $quit_deposit
 * @property string $accumulation_fund
 */
class WagesT extends \common\models\Base
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'wages_t';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['user_id', 'year', 'month', 'call_long', 'overtime'], 'integer'],
            [['basic_wages', 'duties_wages', 'post_wages', 'encourage', 'reward', 'traffic', 'bill', 'leader', 'subsidy', 'late', 'subsidy_ded', 'punish', 'electricity_fees', 'quit_deposit', 'accumulation_fund'], 'number'],
            [['check_work', 'commission'], 'string', 'max' => 200],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'user_id' => 'User ID',
            'year' => 'Year',
            'month' => 'Month',
            'basic_wages' => 'Basic Wages',
            'duties_wages' => 'Duties Wages',
            'post_wages' => 'Post Wages',
            'check_work' => 'Check Work',
            'call_long' => 'Call Long',
            'commission' => 'Commission',
            'encourage' => 'Encourage',
            'reward' => 'Reward',
            'overtime' => 'Overtime',
            'traffic' => 'Traffic',
            'bill' => 'Bill',
            'leader' => 'Leader',
            'subsidy' => 'Subsidy',
            'late' => 'Late',
            'subsidy_ded' => 'Subsidy Ded',
            'punish' => 'Punish',
            'electricity_fees' => 'Electricity Fees',
            'quit_deposit' => 'Quit Deposit',
            'accumulation_fund' => 'Accumulation Fund',
        ];
    }
}
