<?php
use \common\libs\MyLib;
?>
<?php $this->beginBlock('header_css'); ?>
<link href="/assets/css/plugins/bootstrap-table/bootstrap-table.min.css" rel="stylesheet">
<?php $this->endBlock(); ?>

<div class="wrapper wrapper-content animated fadeInRight">
    <div class="ibox float-e-margins">
        <div class="ibox-title">
            <h5>保单查询</h5>
            <div class="ibox-tools">
                <a class="btn btn-primary btn-xs edit-btn" data-id="0" href="javascript:void(0);" onclick="refreshList();">
                    <i class="fa fa-refresh"></i> 刷新
                </a>
            </div>
        </div>
        <div class="ibox-content">
            <form role="form" id="searchFrm" class="form-inline" onsubmit="return search();">
                <div class="form-group" style="margin-bottom: 8px;">
                    <label for="username">车主</label>
                    <input type="text" id="car_man" name="car_man" class="form-control">
                </div>
                <div class="form-group" style="margin-bottom: 8px;margin-left:20px;">
                    <label for="id_man">被保险人</label>
                    <input type="text" id="id_man" name="id_man" class="form-control">
                </div>
                <div class="form-group" style="margin-bottom: 8px;margin-left:20px;">
                    <label for="phone">电话</label>
                    <input type="text" id="phone" name="phone" class="form-control">
                </div>
                <div class="form-group" style="margin-bottom: 8px;margin-left:20px;">
                    <label for="car_no">车牌</label>
                    <input type="text" id="car_no" name="car_no" class="form-control">
                </div>
                <div class="form-group" style="margin-bottom: 8px;">
                    <label for="datepicker1">初登日期</label>
                    <div class="input-group input-daterange" id="datepicker1">
                        <input type="text" class="form-control" id="date_begin" name="date_begin" autocomplete="off" />
                        <div class="input-group-addon">-</div>
                        <input type="text" class="form-control" id="date_end" name="date_end" autocomplete="off" />
                    </div>
                </div>
                <div class="form-group" style="margin-bottom: 8px;margin-left:20px;">
                    <label for="datepicker3">正本日期</label>
                    <div class="input-group input-daterange" id="datepicker3">
                        <input type="text" class="form-control" id="date2_begin" name="date2_begin" autocomplete="off" />
                        <div class="input-group-addon">-</div>
                        <input type="text" class="form-control" id="date2_end" name="date2_end" autocomplete="off" />
                    </div>
                </div>
                <div class="form-group" style="margin-bottom: 8px;">
                    <label for="datepicker2">起保日期</label>
                    <div class="input-group input-daterange" id="datepicker2">
                        <input type="text" class="form-control" id="date3_begin" name="date3_begin" autocomplete="off" />
                        <div class="input-group-addon">-</div>
                        <input type="text" class="form-control" id="date3_end" name="date3_end" autocomplete="off" />
                    </div>
                </div>
                <div class="form-group" style="margin-bottom: 8px;margin-left:20px;">
                    <label for="car_no">状态</label>
                    <select name="status" id="status" class="form-control">
                        <option value="0">全部</option>
                        <option value="1">未完成</option>
                        <option value="2">已完成</option>
                    </select>
                </div>
                <button type="submit" class="btn btn-primary mb-8">搜索</button>
            </form>
            <div class="row" style="margin-top:20px;">
                <div class="col-md-12">
                    <table id="listTable">
                        <thead class="bg-warning">
                        <tr>
                            <th data-field="id">ID</th>
                            <th data-field="car_man">车主</th>
                            <th data-field="id_man">被保险人</th>
                            <th data-field="submit_date">提单日期</th>
                            <th data-field="car_no">车牌号</th>
                            <th data-field="factory_model">厂牌型号</th>
                            <th data-field="total_all">共计签单</th>
                            <th data-field="total_real">应收</th>
                            <th data-field="status">状态</th>
                            <th data-field="username">业务员</th>
                            <th data-field="company_name">保险公司</th>
                            <th data-field="file_status">上传状态</th>
                            <th data-field="lock_name">当前操作</th>
                            <th data-formatter="opFormatter">操作</th>
                        </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<?php $this->beginBlock('footer_js'); ?>
<script src="/assets/js/plugins/bootstrap-table/bootstrap-table.min.js"></script>
<script src="/assets/js/plugins/bootstrap-table/bootstrap-table-mobile.min.js"></script>
<script src="/assets/js/plugins/bootstrap-table/locale/bootstrap-table-zh-CN.min.js"></script>
<script>
    var o = {};
    function opFormatter(value, row, index) {
        var opStr = [];
        opStr.push('<a href="javascript:void(0);" onclick="info(' + row.id + ')">');
        opStr.push('<i class="fa fa-plus" title="详情">&nbsp;详情</i>');
        opStr.push('</a>');

        return opStr.join(' ');
    }

    function info(id) {
        window.open('/insurer/info?id=' + id);
    }

    function refreshList() {
        $('#listTable').bootstrapTable('refresh');
    }

    function search() {
        o = {};
        var params = $("#searchFrm").serializeArray();
        $.each(params, function(index) {
            o[this['name']] = this['value'];
        });
        $('#listTable').bootstrapTable('destroy');
        $('#listTable').bootstrapTable({
            url: "/insurer/search-json",
            pagination: true,
            sidePagination: 'server',
            queryParams: function(params) {
                o['limit'] = params['limit'];
                o['offset'] = params['offset'];
                return o;
            }
        });
        return false;
    }

    $(function() {
        search();

        $('.input-daterange').datepicker({
            keyboardNavigation: false,
            forceParse: false,
            autoclose: true
        });
    });
</script>
<?php $this->endBlock(); ?>
